#!/usr/bin/perl -w

$iconsdir="/usr/local/share/fvwm/themes/cde/modules/images";

# $iconsmall="t";
# $iconmed="m";
# $buttonsize=40;
# $file="buttonbar/Small";

$iconsmall="m";
$iconmed="l";
$buttonsize=60;
$file="buttonbar/Large";


#NBUTTONS HAS TO BE EVEN
$nButtons=8; 
$nPages=5;

#ENTIRE PANEL
$sideBarWidth=1; $sliderHeight=2; $buttonHeight=7; $buttonWidth=3; $centerPanelWidth=5*$buttonWidth; $buttonsCPMargin=1;
$nCols=$buttonWidth*$nButtons+2*$sideBarWidth+$centerPanelWidth+2*$buttonsCPMargin;
$nRows=$sliderHeight+$buttonHeight;

$buttStartLeft=$sideBarWidth;
$buttStartRight=$sideBarWidth+$nButtons/2*$buttonWidth+$centerPanelWidth+2*$buttonsCPMargin;

$buttonsCPMarginLeftX=$buttStartLeft+$nButtons/2*$buttonWidth;
$buttonsCPMarginRightX=$buttStartRight-$buttonsCPMargin;

#CENTER PANEL
$pageTopMargin=1; $pageHeight=10; $pageWidth=3; $toolbarWidth=2;
$cpPagerWidth=$nPages*$pageWidth;
$cpRows=2*$pageTopMargin+$pageHeight;
$cpCols=2*$toolbarWidth+$cpPagerWidth;
$cpX=$buttStartLeft+$nButtons/2*$buttonWidth+$buttonsCPMargin;
$cpToolHeight=int($cpRows/2);

$geomx=int($buttonsize/$buttonWidth*$nCols);
$geomy=int($buttonsize*$nRows/$buttonHeight);


###################
$str="

DeskTopSize $nPages 1

Style \"FvwmPager-Single\" NoTitle, Sticky, WindowListSkip, CirculateSkip, NoHandles 

DestroyModuleConfig FvwmPager-Single: *

*FvwmPager-Single: Colorset * 14
*FvwmPager-Single: HilightColorset * 15
*FvwmPager-Single: WindowColorsets 1 2
*FvwmPager-Single: BalloonColorset * 16 

*FvwmPager-Single: Columns 1
*FvwmPager-Single: Font none
*FvwmPager-Single: SmallFont -*-lucidabright-medium-r-*-*-8-*-*-*-*-*-*-*
*FvwmPager-Single: Balloons            All
*FvwmPager-Single: BalloonFont -*-lucidabright-medium-r-*-*-12-*-*-*-*-*-*-*
*FvwmPager-Single: BalloonYOffset      +2
*FvwmPager-Single: BalloonBorderWidth  1

*FvwmPager-Single: Label 0 Main
*FvwmPager-Single: Label 1 Web & Mail
*FvwmPager-Single: Label 2 Devel
*FvwmPager-Single: Label 3 Games

Style \"CenterPanel\" NoTitle, Sticky, WindowListSkip, CirculateSkip, NoHandles, TitleAtBottom,BorderWidth 1
DestroyModuleConfig CenterPanel: *

*CenterPanel: Colorset 10
*CenterPanelRows $cpRows 
*CenterPanelColumns $cpCols
*CenterPanelBoxSize fixed
*CenterPanel: (".$cpPagerWidth."x$pageHeight+$toolbarWidth+$pageTopMargin, Frame 1, Swallow \"FvwmPager-Single\" \"Module FvwmPager FvwmPager-Single * *\")
*CenterPanel: (".$toolbarWidth."x$cpToolHeight+0+0, Frame 0, Icon $iconsdir/Fplock.$iconsmall.pm,Action Exec klock)
*CenterPanel: (".$toolbarWidth."x$cpToolHeight+0-0, Frame 0)
*CenterPanel: (".$toolbarWidth."x$cpToolHeight-0+0, Frame 0, Icon $iconsdir/Fplite.$iconsmall.pm,Action Restart)
*CenterPanel: (".$toolbarWidth."x$cpToolHeight-0-0, Frame 0, Icon $iconsdir/Fpexit.$iconsmall.pm,Action Menu MenuFvwmQuit)

Style \"FvwmButtons\" NoTitle, Sticky, WindowListSkip, CirculateSkip, NoHandles, TitleAtBottom,BorderWidth 3, fvwmborder

DestroyModuleConfig FvwmButtons: *
*FvwmButtons: Geometry ".$geomx."x$geomy+0-0
*FvwmButtons: Colorset 10
*FvwmButtonsRows $nRows 
*FvwmButtonsColumns $nCols
*FvwmButtonsBoxSize fixed

*FvwmButtons: (".$centerPanelWidth."x$nRows+$cpX+0, Frame 1, Swallow \"CenterPanel\" \"Module FvwmButtons CenterPanel\")
*FvwmButtons: (".$sideBarWidth."x$sliderHeight+0+0, Frame 1,Icon $iconsdir/Fpmenu.$iconmed.pm,Padding 0 0,Colorset 11,Action `Menu MenuFvwmWindowOps2`)
*FvwmButtons: (".$sideBarWidth."x$buttonHeight+0+$sliderHeight, Frame 1,Icon $iconsdir/Fphandl.l.pm, Padding 0 0,Colorset 11, `All (FvwmButtons) Move`)
*FvwmButtons: (".$sideBarWidth."x$sliderHeight-0+0, Frame 1,Icon $iconsdir/Fpmin.pm, Padding 0 0,Colorset 11,Action 'All (FvwmButtons) Iconify')
*FvwmButtons: (".$sideBarWidth."x$buttonHeight-0+$sliderHeight, Frame 1,Icon $iconsdir/Fphandl.l.pm, Padding 0 0,Colorset 11, Action 'All (FvwmButtons) Move')
*FvwmButtons: (".$buttonsCPMargin."x$sliderHeight+$buttonsCPMarginLeftX+0,Frame 1,Colorset 11);
*FvwmButtons: (".$buttonsCPMargin."x$sliderHeight+$buttonsCPMarginRightX+0,Frame 1,Colorset 11);

";

open(OUTFILE, ">$file");
print OUTFILE $str;
Button(-1,1,0,"/root/exit.xpm",", Swallow xclock `Exec xclock -padding 5 -bg  \$[bg.cs10] -fg \$[fg.cs10]`","");
Button(-1,2,0,"$iconsdir/FpCM.$iconmed.pm",",Swallow FvwmApplet-CDEDate `FvwmScript FvwmApplet-CDEDate 11 11`","");
Button(-1,3,1,"$iconsdir/Dtterm.$iconmed.pm",", Action Exec rxvt -font 6x13",",Action Menu MenuFvwmShells");
Button(-1,4,1,"$iconsdir/Netscape.$iconmed.pm",", Action Exec Netscape",",Action Menu MenuFvwmPrograms");
Button(1,1,1,"$iconsdir/Fpstyle.$iconmed.pm",",Action FvwmScript FvwmScript-ThemesCenter",",Action Menu MenuFvwmTheme-Current");
Button(1,2,1,"$iconsdir/Fphome.$iconmed.pm",",Action Exec rxvt -e mc",",Action Menu MenuFvwmSystem");
Button(1,3,0,"$iconsdir/DtMail.$iconmed.pm",",Action Exec Netscape -mail","");
Button(1,4,1,"$iconsdir/Fphelp.$iconmed.pm",",Action Exec xman",",Action Menu MenuFvwmManPages");

print OUTFILE "
AddToFunc   FuncFvwmStartThemeModules
+ I Module FvwmButtons
";
close(OUTFILE);

sub Button { my ($lr,$n,$d,$i,$a,$ba)=@_; my $X;
  if ($lr<0) {$X=$buttStartLeft;} else {$X=$buttStartRight;};
  $X+=($n-1)*$buttonWidth;
$drawer="";
if ($d) {
  $drawer="*FvwmButtons: (".$buttonWidth."x$sliderHeight+$X+0, Frame 1, Icon /root/cdeimg/sliderarrow.xpm, Padding 1 1, Colorset 11$ba)\n";
} else {
  $drawer="*FvwmButtons: (".$buttonWidth."x$sliderHeight+$X+0, Frame 1,Colorset 11)\n";
};
 my $str=$drawer."*FvwmButtons: (".$buttonWidth."x$buttonHeight+$X+$sliderHeight, Frame 0, Icon $i, Padding 0 0$a)\n";
print OUTFILE $str;
} ;


##################################################

# *FvwmButtons: (".$buttonWidth."x$sliderHeight+$X+0, Frame 1)
# *FvwmButtons: (".$buttonWidth."x$buttonHeight+$x+$sliderHeight, Frame 1)

# Button();


#*FvwmButtons: (Frame 2, \
#	Swallow "xbiff" `Exec exec xbiff -bg $[bg.cs13] -fg $[fg.cs13]`)
#*FvwmButtons: (Frame 3, \
#	Swallow(NoHints) "xclock" `Exec exec xclock -bg $[bg.cs13] \
#	-fg $[fg.cs13] -hd $[shadow.cs13] -hl $[hilight.cs13] -padding 0 \
#	-update 1`)
#*FvwmButtons: (2x1, Frame 2,\
#	Swallow(UseOld,NoHints) "xload" `Exec exec xload -bg $[bg.cs13] \
#	-fg $[fg.cs13] -hl $[shadow.cs13] -update 5 -nolabel`)
